Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java	(revision 15787)
@@ -27,5 +27,5 @@
 import org.greenstone.gsdl3.util.XMLConverter;
 
-import org.greenstone.gsdl3.util.GDBMWrapper;
+import org.greenstone.gsdl3.util.SimpleCollectionDatabase;
 import org.greenstone.gsdl3.util.DBInfo;
 // XML classes
@@ -45,8 +45,8 @@
 import java.util.Map.Entry;
 
-import org.apache.log4j.*;
+import org.apache.log4j.Logger;
 
 /** Implements the oai metadata retrieval service for GS3 collections.
- *  Dig into each collection's gdbm database and retrieve the metadata
+ *  Dig into each collection's database and retrieve the metadata
  *
  * @author <a href="mailto:xiao@cs.waikato.ac.nz">Xiao</a>
@@ -57,5 +57,5 @@
   static Logger logger = Logger.getLogger(org.greenstone.gsdl3.service.OAIPMH.class.getName());
   
-  protected GDBMWrapper gdbm_src = null;
+  protected SimpleCollectionDatabase coll_db = null;
   
   protected String site_name = "";
@@ -65,10 +65,10 @@
   /** constructor */
   public OAIPMH() {
-    this.gdbm_src = new GDBMWrapper();
+
   }
   
   public void cleanUp() {
     super.cleanUp();//??
-    this.gdbm_src.closeDatabase();
+    this.coll_db.closeDatabase();
   }
   /** configure this service */
@@ -89,21 +89,36 @@
     this.config_info = info;
     
-	// the index stem is either specified in the buildConfig.xml file or uses the collection name
-	Element index_stem_elem = (Element) GSXML.getChildByTagName(info, GSXML.INDEX_STEM_ELEM);
-	String index_stem = null;
-	if (index_stem_elem != null) {
-	    index_stem = index_stem_elem.getAttribute(GSXML.NAME_ATT);
-	}
-	if (index_stem == null || index_stem.equals("")) {
-	    index_stem = this.cluster_name;
-	}
+    // the index stem is either specified in the buildConfig.xml file or uses the collection name
+    Element index_stem_elem = (Element) GSXML.getChildByTagName(info, GSXML.INDEX_STEM_ELEM);
+    String index_stem = null;
+    if (index_stem_elem != null) {
+      index_stem = index_stem_elem.getAttribute(GSXML.NAME_ATT);
+    }
+    if (index_stem == null || index_stem.equals("")) {
+      index_stem = this.cluster_name;
+    }
   
-    // Open GDBM database for querying
-    String gdbm_db_file = GSFile.GDBMDatabaseFile(this.site_home, this.cluster_name, index_stem);
-    if (!this.gdbm_src.openDatabase(gdbm_db_file, GDBMWrapper.READER)) {
-      logger.error("Could not open GDBM database!");
+    // find out what kind of database we have
+    Element database_type_elem = (Element) GSXML.getChildByTagName(info, GSXML.DATABASE_TYPE_ELEM);
+    String database_type = null;
+    if (database_type_elem != null) {
+      database_type = database_type_elem.getAttribute(GSXML.NAME_ATT);
+    }
+    if (database_type == null || database_type.equals("")) {
+      database_type = "gdbm"; // the default
+    }
+    coll_db = new SimpleCollectionDatabase(database_type);
+    if (coll_db == null) {
+      logger.error("Couldn't create the collection database of type "+database_type);
       return false;
     }
-
+    
+    // Open database for querying
+    String coll_db_file = GSFile.collectionDatabaseFile(this.site_home, this.cluster_name, index_stem, database_type);
+    if (!this.coll_db.openDatabase(coll_db_file, SimpleCollectionDatabase.READ)) {
+      logger.error("Could not open collection database!");
+      return false;
+    }
+    
     // the short_service_info is used by the message router to find the method names, 
     //so we just use the doc variable in class ServiceRack to create the xml; but
@@ -214,5 +229,5 @@
     //get a DBInfo object of the identifier; if this identifier is not present in the database,
     // null is returned.
-    DBInfo info = this.gdbm_src.getInfo(oid);
+    DBInfo info = this.coll_db.getInfo(oid);
     if (info == null) {
       logger.error("OID: " + oid + " is not present in the database.");
@@ -294,5 +309,5 @@
     for(int i=0; i<oid_list.size(); i++) {
       String oid = (String)oid_list.get(i);
-      DBInfo info = this.gdbm_src.getInfo(oid);
+      DBInfo info = this.coll_db.getInfo(oid);
       if (info == null) {
         logger.error("Database does not contains information about oid: " +oid);
@@ -386,5 +401,5 @@
     for(int i=0; i<oid_list.size(); i++) {
       String oid = (String)oid_list.get(i);
-      DBInfo info = this.gdbm_src.getInfo(oid);
+      DBInfo info = this.coll_db.getInfo(oid);
       if (info == null) {
         logger.error("Database does not contains information about oid: " +oid);
@@ -506,5 +521,5 @@
     
     DBInfo info = null;    
-    info = this.gdbm_src.getInfo(oid);
+    info = this.coll_db.getInfo(oid);
     if (info == null) { //just double check
       return OAIXML.getResponse(OAIXML.createErrorElement(OAIXML.OAI_SERVICE_UNAVAILABLE, ""));
@@ -577,5 +592,5 @@
   /** returns a list of the child ids in order, null if no children */
   protected ArrayList getChildrenIds(String node_id) {
-    DBInfo info = this.gdbm_src.getInfo(node_id);
+    DBInfo info = this.coll_db.getInfo(node_id);
     if (info == null) {
       return null;
@@ -614,5 +629,5 @@
   }  
     /** @param keys - contains a list of keys in string format.
-     * Here is a typical record in the gdbm database, 'keys' contains the values in <...>:
+     * Here is a typical record in the collection database, 'keys' contains the values in <...>:
      *----------------------------------------------------------------------
 [HASH01a84acb0f1aad2380493b3a]
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/FlatDatabaseWrapper.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/FlatDatabaseWrapper.java	(revision 15787)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/FlatDatabaseWrapper.java	(revision 15787)
@@ -0,0 +1,41 @@
+/*
+ *    FlatDatabaseWrapper.java
+ *    Copyright (C) 2008 New Zealand Digital Library, http://www.nzdl.org
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with this program; if not, write to the Free Software
+ *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+package org.greenstone.gsdl3.util;
+
+public interface FlatDatabaseWrapper {
+
+  /* just read access, many readers can share a database */
+  public final static int READ = 0;
+  /* read/write, exclusive access */
+  public final static int WRITE = 1;
+
+  // do we want the other modes? 
+  // -- read/write - create if doesn't exist 
+  // -- read/write - create a new database
+  /** open database named filename, using mode */
+  public boolean openDatabase(String filename, int mode);
+
+  /** close the database associated with this wrapper */
+  public void closeDatabase();
+
+  /** returns the value associated with the key */
+  public String getValue(String key);
+
+}
+
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java	(revision 15787)
@@ -5,5 +5,5 @@
 import au.com.pharos.gdbm.GdbmException;
 
-import org.apache.log4j.*;
+import org.apache.log4j.Logger;
 
 /** java wrapper class for gdbm - uses Java-GDBM written by Martin Pool
@@ -11,289 +11,94 @@
  */
 
-public class GDBMWrapper {
+public class GDBMWrapper 
+  implements FlatDatabaseWrapper {
 
-      static Logger logger = Logger.getLogger(org.greenstone.gsdl3.util.GDBMWrapper.class.getName());
-
-
-    // Values must match those from gdbm.h - uses the definitions from GdbmFile !
-    /** Indicates that the caller will just read the database.  Many
-     * readers may share a database. */
-    public final static int READER = GdbmFile.READER;
- 
-    /** The caller wants read/write access to an existing database and
-     * requires exclusive access. */
-    public final static int WRITER = GdbmFile.WRITER;
- 
-    /** The caller wants exclusive read/write access, and the database
-     * should be created if it does not already exist. */
-    public final static int WRCREAT = GdbmFile.WRCREAT;
- 
-    /** The caller wants exclusive read/write access, and the database
-     * should be replaced if it already exists. */
-    public final static int NEWDB = GdbmFile.NEWDB;
+  static Logger logger = Logger.getLogger(org.greenstone.gsdl3.util.GDBMWrapper.class.getName());
+  
+  /* GdbmFile modes:
+     READER - read access, many readers may share the database
+     WRITER - read/write access, exclusive access
+     WRCREAT - read/write access, create db if doesn't exist
+     NEWDB - read/write access, db should be replaced if exists
+  */
+  
 
     protected GdbmFile db_=null;
 
-    /** open the database filename, with mode mode - uses the constants
-	above, eg GdbmFile.WRITER */
-    public boolean openDatabase(String filename, int mode){
-	try {
-	    if (db_!=null) {
-		db_.close();
-	    }
-	    db_ = new GdbmFile(filename, mode);
-	} catch ( GdbmException e) { // the database wasn't opened or created
-	    logger.error("couldn't open database "+filename);
-	    return false;
-	} 
-	db_.setKeyPacking(new StringPacking());
-	db_.setValuePacking(new StringPacking());
-	return true;
+  /** open the database filename, with mode mode - uses the constants
+      above, eg GdbmFile.WRITER */
+  public boolean openDatabase(String filename, int mode) {
+    // need to convert mode to GdbmFile mode
+    if (mode == READ) { 
+      mode = GdbmFile.READER;
+    } else if (mode == WRITE) {
+      mode = GdbmFile.WRITER;
+    }	else {
+      logger.error ("invalid mode, "+mode+ ", opening db for reading only");
+      mode = GdbmFile.READER;
     }
+      
+    try {
+      if (db_!=null) {
+	db_.close();
+      }
+      db_ = new GdbmFile(filename, mode);
+    } catch ( GdbmException e) { // the database wasn't opened or created
+      logger.error("couldn't open database "+filename);
+      return false;
+    } 
+    db_.setKeyPacking(new StringPacking());
+    db_.setValuePacking(new StringPacking());
+    return true;
+  }
+  
+  /** close the database associated with this wrapper */
+  public void closeDatabase() {
+    try {
+      if (db_ != null) {
+	db_.close();
+	db_ = null;
+      }
+    } catch (GdbmException e) {
+      // should never get here - close never actually throws an exception
+      logger.error("error on close()");
+    }
+  }
 
-    /** close the database associated with this wrapper */
-    public void closeDatabase() {
-	try {
-	    if (db_ != null) {
-		db_.close();
-		db_ = null;
-	    }
-	} catch (GdbmException e) {
-	    // should never get here - close never actually throws an exception
-	    logger.error("error on close()");
-	}
+  public String getValue(String key) {
+    if (db_==null) {
+      return null;
     }
+    String s_info;
+    try {
+      s_info = (String)db_.fetch(key);
+    } catch (GdbmException e) {
+      logger.error("couldn't get record");
+      return null;
+    }
+    if (s_info==null) {
+      // record not present
+      logger.error("key "+key+" not present in db");
+      return null;
+    }
+    return s_info;
+  }
 
-    /** returns a DBInfo object containing all the name-value pairs for 
-     * main_key 
-     * @see DBInfo
-     */
-    public DBInfo getInfo(String main_key) {
-	if (db_==null) {
-	    return null;
-	}
-	String s_info;
-	try {
-	    s_info = (String)db_.fetch(main_key);
-	} catch (GdbmException e) {
-	    logger.error("couldn't get record");
-	    return null;
-	}
-	if (s_info==null) {
-	    // record not present
-	    logger.error("key "+main_key+" not present in db");
-	    return null;
-	}
-	DBInfo info = new DBInfo();
+  /** sets the key value as info 
+   * TODO - not implemented yet */
+  public boolean setValue (String key, String value) {
+    if (db_==null) {
+      return false;
+    }
+    return false;
+  }
+  /** deletes the entry for key 
+   * TODO - not implemented yet */
+  public boolean deleteKey(String key) {
+    if (db_==null) {
+      return false;
+    }
+    return false;
+  }
 
-	String [] lines = s_info.split("\n");
-	String key;
-	String value;
-	for (int i=0; i<lines.length; i++) {
-	    logger.debug("line:"+lines[i]);
-	    int a = lines[i].indexOf('<');
-	    int b= lines[i].indexOf('>');
-	    if (a==-1 || b==-1) {
-		logger.error("bad format in db");
-	    }
-	    else {
-		key=lines[i].substring(a+1, b);
-		value=lines[i].substring(b+1);
-		logger.debug("key="+key+", val="+value);
-		info.addInfo(key, value);
-
-	    }
-	}
-	return info;
-    }
-
-    /** sets all the name-value pairs in info as the content for key key 
-     * TODO - not implemented yet */
-    public boolean setInfo(String key, DBInfo info) {
-	if (db_==null) {
-	    return false;
-	}
-	return true;
-    }
-    /** sets the key value as info 
-     * TODO - not implemented yet */
-    public boolean setInfo (String key, String info) {
-	if (db_==null) {
-	    return false;
-	}
-	return true;
-    }
-    /** deletes the entry for key 
-     * TODO - not implemented yet */
-    public boolean deleteKey(String key) {
-	if (db_==null) {
-	    return false;
-	}
-	return true;
-    }
-
-    // greenstone convenience methods - should these go into a separate class?
-    // yes I think so.
-    /** converts a greenstone OID to internal docnum */
-    public long OID2Docnum(String OID) {
-	DBInfo info = getInfo(OID);
-	if (info != null) {
-	    long real_num = Long.parseLong(info.getInfo("docnum"));
-	    return real_num;
-	}
-	return -1;
-    }
-    /** converts a docnum to greenstone OID */
-    public String docnum2OID(long docnum) {
-	return docnum2OID(Long.toString(docnum));
-    }
-    
-    /** converts a docnum to greenstone OID */
-    public String docnum2OID(String docnum) {
-	DBInfo info = getInfo(docnum);
-	if (info!=null){
-	    String oid = info.getInfo("section");
-	    return oid;
-	}else{
-	    return null;
-	}
-    }
-
-    /** converts an external id to greenstone OID */
-    public String externalId2OID(String extid) {
-	DBInfo info = getInfo(extid);
-	if (info != null) {
-	    String oid = info.getInfo("section");
-	    return oid;
-	}
-	return null;
-    }
-    /** translates relative oids into proper oids:
-     * .pr (parent), .rt (root) .fc (first child), .lc (last child),
-     * .ns (next sibling), .ps (previous sibling) 
-     * .np (next page), .pp (previous page) : links sections in the order that you'd read the document
-     * a suffix is expected to be present so test before using 
-     */
-    public String translateOID(String oid) {
-
-	int p = oid.lastIndexOf('.');
-	if (p != oid.length()-3) {
-	    logger.info("translateoid error: '.' is not the third to last char!!");
-	    return oid;
-	}
-	
-	String top = oid.substring(0, p);
-	String suff = oid.substring(p+1);
-	// just in case we have multiple extensions, we must translate
-	// we process inner ones first
-	if (OID.needsTranslating(top)) {
-	    top = translateOID(top);
-	}
-	if (suff.equals("pr")) {
-	    return OID.getParent(top);
-	} 
-	if (suff.equals("rt")) {
-	    return OID.getTop(top);
-	} 
-	if (suff.equals("np")) {
-	    // try first child
-	    String node_id = translateOID(top+".fc");
-	    if (!node_id.equals(top)) {
-		return node_id;
-	    }
-	    // try next sibling
-	    node_id = translateOID(top+".ns");
-	    if (!node_id.equals(top)) {
-		return node_id;
-	    }
-	    // otherwise we keep trying parents sibling
-	    String child_id = top;
-	    String parent_id = OID.getParent(child_id);
-	    while(!parent_id.equals(child_id)) {
-		node_id = translateOID(parent_id+".ns");
-		if (!node_id.equals(parent_id)) {
-		    return node_id;
-		}
-		child_id = parent_id;
-		parent_id = OID.getParent(child_id);
-	    }
-	    return top; // we couldn't get a next page, so just return the original
-	} 
-	if (suff.equals("pp")) {
-	    String prev_sib = translateOID(top+".ps");
-	    if (prev_sib.equals(top)) {
-		// no previous sibling, so return the parent
-		return OID.getParent(top);
-	    }
-	    // there is a previous sibling, so its either this section, or the last child of the last child..
-	    String last_child = translateOID(prev_sib+".lc");
-	    while (!last_child.equals(prev_sib)) {
-		prev_sib = last_child;
-		last_child = translateOID(prev_sib+".lc");
-	    }
-	    return last_child;
-	} 
-	
-	int sibling_num = 0;
-	if (suff.equals("ss")) {
-	    // we have to remove the sib num before we get top
-	    p = top.lastIndexOf('.');
-	    sibling_num = Integer.parseInt(top.substring(p+1));
-	    top = top.substring(0, p);
-	}
-	
-	// need to get info out of gdbm db -
-	String doc_id = top;
-	if (suff.endsWith("s")) {
-	    doc_id = OID.getParent(top);
-	    if (doc_id.equals(top)) {
-		// i.e. we are already at the top
-		return top;
-	    }
-	}
-	DBInfo info = getInfo(doc_id);
-	if (info==null) {
-	    logger.info("info is null!!");
-	    return top;
-	}
-	
-	String contains = info.getInfo("contains");
-	if (contains.equals("")) {
-	    // something is wrong
-	    return top;
-	}
-	contains = contains.replaceAll("\"", doc_id);
-	String [] children = contains.split(";");
-	if (suff.equals("fc")) {
-	    return children[0];
-	} else if (suff.equals("lc")) {
-	    return children[children.length-1];
-	} else {
-	    if (suff.equals("ss")) {
-		return children[sibling_num-1];
-	    }
-	    // find the position that we are at.
-	    int i=0;
-	    while (i<children.length) {
-		if (children[i].equals(top)) {
-		    break;
-		}
-		i++;
-	    }
-	    
-	    if (suff.equals("ns")) {
-		if (i==children.length-1) {
-		    return children[i];
-		}
-		return children[i+1];
-	    } else if (suff.equals("ps")) {
-		if (i==0) {
-		    return children[i];
-		}
-		return children[i-1];
-	    }
-	}
-	
-	return top;
-    }
 }
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java	(revision 15787)
@@ -28,10 +28,18 @@
 {
 
-    protected GDBMWrapper gdbm_src = null;
+    protected SimpleCollectionDatabase coll_db = null;
     
     // need to make it not add macros if they are already present
-    public GS2MacroResolver(GDBMWrapper gdbm) {
+    public GS2MacroResolver(SimpleCollectionDatabase db) {
 	super();
-	gdbm_src = gdbm;
+	coll_db = db;
+    }
+
+    public GS2MacroResolver() {
+	super();
+    }
+
+    public void setDB(SimpleCollectionDatabase db) {
+	this.coll_db = db;
     }
 
@@ -107,5 +115,5 @@
 		if (match.matches()) {
 		    if (node_info == null) {
-			node_info = gdbm_src.getInfo(doc_oid);
+			node_info = coll_db.getInfo(doc_oid);
 			if (node_info == null) {
 			    break;
@@ -116,5 +124,5 @@
 			// try the root node
 			if (root_info == null && !OID.isTop(doc_oid)) {
-			    root_info = gdbm_src.getInfo(OID.getTop(doc_oid));
+			    root_info = coll_db.getInfo(OID.getTop(doc_oid));
 			}
 			if (root_info == null) break;
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java	(revision 15787)
@@ -289,18 +289,27 @@
     }
 
-    /** the gdbm database file - 
-     * note, need to change extension depending on OS */
+    /** the collection database file - 
+     * note, need to change extension depending on OS and database type */
     // The perl code can't detect big vs little endian on a Mac, so the Perl
     // code will always name the gdbm db file .bdb on a Mac whether its little
     // endian or not. A Mac little endian file is NOT the same as a Linux 
     // little endian file
-    static public String GDBMDatabaseFile(String site_home, 
-					  String collection_name,
-					  String index_stem) {
-
-	String db_ext = ".ldb";
-	if (Misc.isMac() || Misc.isBigEndian()) {
+  // jdbm files are endian independent ??
+    static public String collectionDatabaseFile(String site_home, 
+						String collection_name,
+						String index_stem, 
+						String database_type) {
+
+        String db_ext = null;
+	if (database_type.equalsIgnoreCase("jdbm")) {
+	  db_ext = ".db";
+	} else {
+	  // assume gdbm
+	  db_ext = ".ldb";
+	  if (Misc.isMac() || Misc.isBigEndian()) {
 	    db_ext = ".bdb";
-	}
+	  }
+	} 
+	
 	return site_home + File.separatorChar +
 	    "collect" + File.separatorChar +
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 15787)
@@ -64,8 +64,8 @@
   public static final String DISPLAY_ELEM = "display";
   public static final String LEVEL_ELEM = "level";
+  public static final String DATABASE_TYPE_ELEM = "databaseType";
   public static final String SHORTNAME_ATT = "shortname";
   public static final String NOTIFY_ELEM = "notify";
   public static final String NOTIFY_HOST_ATT = "host";
-  
   // elems for the pages to be processed by xslt
   public final static String PAGE_ELEM = "page";
@@ -423,13 +423,19 @@
   /** returns the (first) child element with the given name */
   public static Node getChildByTagName(Node n, String name) {
-    
-    Node child = n.getFirstChild();
-    while (child!=null) {
-      if (child.getNodeName().equals(name)) {
-        return child;
-      }
-      child = child.getNextSibling();
-    }
-    return null; //not found
+      if(n != null) { // this line is an attempted solution to the NullPointerException mentioned 
+	  // in trac bug ticket #225. If n is null can't do n.getFirstChild() below. As per bug #225: 
+	  // GSXML.getNodeByPath() is called by GS2BrowseAction, which then calls this method.
+	  // If n is null, null will be returned which GS2BrowseAction already checks for. It's here
+	  // that the NullPointerException was thrown.
+ 
+	  Node child = n.getFirstChild();
+	  while (child!=null) {
+	      if (child.getNodeName().equals(name)) {
+		  return child;
+	      }
+	      child = child.getNextSibling();
+	  }
+      }
+      return null; //not found
   }
   
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/JDBMWrapper.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/JDBMWrapper.java	(revision 15787)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/JDBMWrapper.java	(revision 15787)
@@ -0,0 +1,44 @@
+/*
+ *    JDBMWrapper.java
+ *    Copyright (C) 2008 New Zealand Digital Library, http://www.nzdl.org
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with this program; if not, write to the Free Software
+ *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+package org.greenstone.gsdl3.util;
+
+import org.apache.log4j.Logger;
+
+public class JDBMWrapper
+  implements FlatDatabaseWrapper {
+  
+  static Logger logger = Logger.getLogger(org.greenstone.gsdl3.util.JDBMWrapper.class.getName());
+
+  /** open database named filename, using mode */
+  public boolean openDatabase(String filename, int mode) {
+    return false;
+  }
+
+
+  /** close the database associated with this wrapper */
+  public void closeDatabase() {
+
+  }
+
+  /** returns the value associated with the key */
+  public String getValue(String key) {
+    return null;
+  }
+
+}
Index: greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/OAIXML.java
===================================================================
--- greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/OAIXML.java	(revision 15191)
+++ greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/OAIXML.java	(revision 15787)
@@ -121,5 +121,5 @@
     public static final String NO_METADATA_FORMATS = "noMetadataFormats";
     
-    // The node id in the gdbm database, which contains all the OIDs in the database
+    // The node id in the collection database, which contains all the OIDs in the database
     public static final String BROWSELIST = "browselist";
         
